diff --git a/nanny/policy.c b/nanny/policy.c
index 8c0d2eed5..207fdce0d 100644
--- a/nanny/policy.c
+++ b/nanny/policy.c
@@ -7,17 +7,6 @@
 #include "config.h"
 #endif
 
-#include <sys/poll.h>
-#include <stdio.h>
-#include <stdarg.h>
-#include <string.h>
-#include <stdlib.h>
-#include <unistd.h>
-#include <signal.h>
-#include <getopt.h>
-#include <limits.h>
-#include <errno.h>
-
 #include <wicked/netinfo.h>
 #include <wicked/addrconf.h>
 #include <wicked/logging.h>
@@ -29,83 +18,145 @@
 #include <wicked/dbus-errors.h>
 #include <wicked/fsm.h>
 
-#include "util_priv.h"
 #include "nanny.h"
+#include "util_priv.h"
 #include "client/ifconfig.h"
 
-ni_bool_t
-ni_managed_policy_filename(const char *name, char *path, size_t size)
+#include <stdio.h>
+#include <errno.h>
+#include <unistd.h>
+
+const char *
+ni_nanny_policy_location(char **location, const char *name)
 {
-	if (path && !ni_string_empty(name)) {
-		snprintf(path, size, "%s/%s.xml", ni_nanny_statedir(), name);
-		return TRUE;
-	}
+	if (!location || ni_string_empty(name))
+		return NULL;
 
-	return FALSE;
+	return ni_string_printf(location, "<%s>", name);
 }
 
-static ni_bool_t
-ni_managed_policy_save_node(const xml_node_t *pnode)
+const char *
+ni_nanny_policy_file_name(char **file, const char *name)
+{
+	if (!file || ni_string_empty(name))
+		return NULL;
+
+	return ni_string_printf(file, "%s" NI_NANNY_POLICY_XML, name);
+}
+
+const char *
+ni_nanny_policy_file_path(char **path, const char *name)
+{
+	const char *dir = ni_nanny_statedir();
+
+	if (!path || ni_string_empty(name) || ni_string_empty(dir))
+		return NULL;
+
+	return ni_string_printf(path, "%s/%s" NI_NANNY_POLICY_XML, dir, name);
+}
+
+ni_bool_t
+ni_nanny_policy_drop(const char *name)
 {
-	char path[PATH_MAX - sizeof(".XXXXXX")] = {'\0'};
-	char temp[PATH_MAX] = {'\0'};
-	const char *pname;
-	FILE *fp;
-	int fd;
+	char *path = NULL;
 
-	if (xml_node_is_empty(pnode))
+	if (!ni_nanny_policy_file_path(&path, name)) {
+		ni_error("Cannot construct path to remove policy '%s'", name);
 		return FALSE;
+	}
 
-	pname = ni_ifpolicy_get_name(pnode);
-	if (ni_string_empty(pname))
+	if (unlink(path) < 0 && errno != ENOENT) {
+		ni_error("Cannot remove policy file '%s': %m", path);
+		ni_string_free(&path);
 		return FALSE;
+	} else {
+		ni_string_free(&path);
+		return TRUE;
+	}
+}
 
-	ni_managed_policy_filename(pname, path, sizeof(path));
-	snprintf(temp, sizeof(temp), "%s.XXXXXX", path);
+ni_bool_t
+ni_nanny_policy_save(const xml_node_t *policy, const char *path, const char *bak)
+{
+	char *tmp = NULL;
+	char *old = NULL;
+	FILE *fp = NULL;
+	int fd = -1;
 
-	if ((fd = mkstemp(temp)) < 0) {
-		ni_error("Cannot create %s policy temp file", path);
+	if (xml_node_is_empty(policy) || ni_string_empty(path))
 		return FALSE;
+
+	if (!ni_string_empty(bak)) {
+		if (!ni_string_printf(&old, "%s%s", path, bak)) {
+			ni_error("Cannot construct policy backup file name '%s%s'",
+					path, bak);
+			goto failure;
+		}
+	}
+
+	if (!ni_string_printf(&tmp, "%s.XXXXXX", path))
+		goto failure;
+
+	if ((fd = mkstemp(tmp)) < 0) {
+		ni_error("Cannot create temporary policy file '%s': %m", path);
+		goto failure;
 	}
 
 	if (!(fp = fdopen(fd, "we"))) {
 		close(fd);
-		ni_error("Cannot create %s policy temp file", path);
+		ni_error("Cannot open temporary policy file '%s': %m", path);
 		goto failure;
 	}
 
-	if (xml_node_print(pnode, fp) < 0) {
-		ni_error("Cannot write into %s policy temp file", path);
+	if (xml_node_print(policy, fp) < 0) {
+		ni_error("Cannot write into temporary policy file '%s'", path);
 		goto failure;
+	} else {
+		fclose(fp);
+		fp = NULL;
 	}
 
-	if (rename(temp, path) < 0) {
-		ni_error("Cannot move temp file to policy file %s", path);
+	if (old && rename(path, old) < 0 && errno != ENOENT)
+		ni_warn("Cannot create policy backup file '%s': %m", old);
+
+	if (rename(tmp, path) < 0) {
+		ni_error("Cannot move temporary file to policy file '%s'", path);
 		goto failure;
 	}
 
-	fclose(fp);
-
 	return TRUE;
 
 failure:
-	if (fp) {
+	if (fp)
 		fclose(fp);
-	}
-	unlink(temp);
+	if (tmp)
+		unlink(tmp);
+	ni_string_free(&tmp);
+	ni_string_free(&old);
 	return FALSE;
 }
 
 static ni_bool_t
 ni_managed_policy_save(const ni_managed_policy_t *mpolicy)
 {
-	const xml_node_t *node;
+	const xml_node_t *policy;
+	const char *name;
+	char *path = NULL;
+	ni_bool_t ret;
 
 	if (!mpolicy)
 		return FALSE;
 
-	node = ni_fsm_policy_node(mpolicy->fsm_policy);
-	return ni_managed_policy_save_node(node);
+	if (!(policy = ni_fsm_policy_node(mpolicy->fsm_policy)))
+		return FALSE;
+
+	name = ni_ifpolicy_get_name(policy);
+	if (!(ni_nanny_policy_file_path(&path, name)))
+		return FALSE;
+
+	ret = ni_nanny_policy_save(policy, path, NULL);
+	ni_string_free(&path);
+	return ret;
 }
 
 void
diff --git a/schema/Makefile.am b/schema/Makefile.am
index 462dc0449..258708044 100644
--- a/schema/Makefile.am
+++ b/schema/Makefile.am
@@ -8,7 +8,7 @@ wicked_schema_DATA		= \
 
 wicked_schema_files		= \
 	addrconf.xml		\
-	bonding.xml		\
+	bond.xml		\
 	bridge.xml		\
 	ethtool.xml		\
 	ethernet.xml		\
diff --git a/schema/constants.xml.in b/schema/constants.xml.in
index 8f3f9e3b7..705565528 100644
--- a/schema/constants.xml.in
+++ b/schema/constants.xml.in
@@ -92,16 +92,16 @@
 <define name="builtin-bonding-mii-carrier-detect" type="uint32" constraint="enum">
   <description>
     Specifies whether the MII monitor will use the netif network interface carrier
-    or the deprecated MII / ETHTOOL ioctls to determine the status of the slaves.
+    or the deprecated MII / ETHTOOL ioctls to determine the status of the ports.
     Default is to query netif carrier, but when the MII monitor fails to detect
-    carrier loss (e.g. disconnected cable) of a slave or it appears that the MII
+    carrier loss (e.g. disconnected cable) of a port or it appears that the MII
     monitor is very slow in detecting link failures, try specifying ioctl.
   </description>
   <@@BONDING_MII_CARRIER_DETECT_NAME@@ value="@@BONDING_MII_CARRIER_DETECT_VALUE@@"/>
 </define>
 <define name="builtin-bonding-xmit-hash-policy" type="uint32" constraint="enum">
   <description>
-    Selects the transmit hash policy to use for slave selection in balance-xor
+    Selects the transmit hash policy to use for port selection in balance-xor
     and 802.3ad modes. The policies layer2 and layer23 are ieee802-3ad compliant.
   </description>
   <@@BONDING_XMIT_HASH_NAME@@ value="@@BONDING_XMIT_HASH_VALUE@@"/>
@@ -121,27 +121,32 @@
 </define>
 <define name="builtin-bonding-fail-over-mac" type="uint32" constraint="enum">
   <description>
-    Specifies whether active-backup mode should set all slaves to the same
-    MAC address at enslavement, or perform special handling of the bond's
+    Specifies whether active-backup mode should set all ports to the same
+    MAC address at linking time, or perform special handling of the bond's
     MAC address in accordance with the selected policy.
   </description>
   <@@BONDING_FAIL_OVER_MAC_NAME@@ value="@@BONDING_FAIL_OVER_MAC_VALUE@@"/>
 </define>
 <define name="builtin-bonding-primary-reselect" type="uint32" constraint="enum">
   <description>
-    Specifies the reselection policy for the primary slave. This affects how
-    the primary slave is chosen to become the active slave when failure of
-    the active slave or recovery of the primary slave occurs. This option
-    is designed to prevent flip-flopping between the primary slave and other
-    slaves.
+    Specifies the reselection policy for the primary port. This affects how
+    the primary port is chosen to become the active port when failure of
+    the active port or recovery of the primary port occurs. This option
+    is designed to prevent flip-flopping between the primary port and other
+    ports.
   </description>
   <@@BONDING_PRIMARY_RESELECT_NAME@@ value="@@BONDING_PRIMARY_RESELECT_VALUE@@"/>
 </define>
-<define name="builtin-bonding-slave-state" type="uint32" constraint="enum">
-  <@@BONDING_SLAVE_STATE_NAME@@ value="@@BONDING_SLAVE_STATE_VALUE@@"/>
+<define name="builtin-bonding-port-state" type="uint32" constraint="enum">
+  <@@BONDING_PORT_STATE_NAME@@ value="@@BONDING_PORT_STATE_VALUE@@"/>
 </define>
-<define name="builtin-bonding-slave-mii-status" type="uint32" constraint="enum">
-  <@@BONDING_SLAVE_MII_STATUS_NAME@@ value="@@BONDING_SLAVE_MII_STATUS_VALUE@@"/>
+<define name="builtin-bonding-port-mii-status" type="uint32" constraint="enum">
+  <@@BONDING_PORT_MII_STATUS_NAME@@ value="@@BONDING_PORT_MII_STATUS_VALUE@@"/>
+</define>
+
+<!-- Built-in bridge & port constants -->
+<define name="builtin-bridge-port-state" type="uint32" constraint="enum">
+  <@@BRIDGE_PORT_STATE_NAME@@ value="@@BRIDGE_PORT_STATE_VALUE@@" />
 </define>
 
 <!-- Built-in route type/scope/table/protocol -->
diff --git a/src/bonding.c b/src/bonding.c
index 05882f993..ec51507dc 100644
--- a/src/bonding.c
+++ b/src/bonding.c
@@ -1,7 +1,21 @@
 /*
- * Routines for handling bonding devices
+ *	Routines for bonding interface handling
  *
- * Copyright (C) 2009-2012 Olaf Kirch <okir@suse.de>
+ *	Copyright (C) 2009-2012 Olaf Kirch <okir@suse.de>
+ *	Copyright (C) 2009-2023 SUSE LLC
+ *
+ *	This program is free software; you can redistribute it and/or modify
+ *	it under the terms of the GNU General Public License as published by
+ *	the Free Software Foundation; either version 2 of the License, or
+ *	(at your option) any later version.
+ *
+ *	This program is distributed in the hope that it will be useful,
+ *	but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *	GNU General Public License for more details.
+ *
+ *	You should have received a copy of the GNU General Public License
+ *	along with this program. If not, see <http://www.gnu.org/licenses/>.
  */
 #ifdef HAVE_CONFIG_H
 #include "config.h"
@@ -19,11 +33,6 @@
 #include "sysfs.h"
 #include "modprobe.h"
 
-/*
- * Slave array (re)allocation chunk
- */
-#define NI_BONDING_SLAVE_ARRAY_CHUNK		4
-
 
 /*
  * Kernel module and default parameter.
@@ -135,19 +144,19 @@ static const ni_intmap_t	__map_user_carrier_detect[] = {
 };
 
 /*
- * Bonding slave state and mii_status maps
+ * Bonding port state and mii_status maps
  */
-static const ni_intmap_t	ni_bonding_slave_state_map[] = {
-	{ "active",		NI_BOND_SLAVE_STATE_ACTIVE	},
-	{ "backup",		NI_BOND_SLAVE_STATE_BACKUP	},
+static const ni_intmap_t	ni_bonding_port_state_map[] = {
+	{ "active",		NI_BOND_PORT_STATE_ACTIVE	},
+	{ "backup",		NI_BOND_PORT_STATE_BACKUP	},
 
 	{ NULL,			-1U				}
 };
-static const ni_intmap_t	ni_bonding_slave_mii_status_map[] = {
-	{ "up",			NI_BOND_SLAVE_LINK_UP		},
-	{ "fail",		NI_BOND_SLAVE_LINK_FAIL		},
-	{ "down",		NI_BOND_SLAVE_LINK_DOWN		},
-	{ "back",		NI_BOND_SLAVE_LINK_BACK		},
+static const ni_intmap_t	ni_bonding_port_mii_status_map[] = {
+	{ "up",			NI_BOND_PORT_LINK_UP		},
+	{ "fail",		NI_BOND_PORT_LINK_FAIL		},
+	{ "down",		NI_BOND_PORT_LINK_DOWN		},
+	{ "back",		NI_BOND_PORT_LINK_BACK		},
 
 	{ NULL,			-1U				}
 };
@@ -195,7 +204,6 @@ __ni_bonding_clear(ni_bonding_t *bonding)
 {
 	ni_netdev_ref_destroy(&bonding->primary_slave);
 	ni_netdev_ref_destroy(&bonding->active_slave);
-	ni_bonding_slave_array_destroy(&bonding->slaves);
 	ni_string_array_destroy(&bonding->arpmon.targets);
 	memset(bonding, 0, sizeof(*bonding));
 
@@ -220,7 +228,6 @@ ni_bonding_t *
 ni_bonding_clone(const ni_bonding_t *orig)
 {
 	ni_bonding_t *bond;
-	unsigned int i;
 
 	if (!orig || !(bond = ni_bonding_new()))
 		return NULL;
@@ -269,13 +276,6 @@ ni_bonding_clone(const ni_bonding_t *orig)
 	ni_netdev_ref_set(&bond->active_slave,  orig->active_slave.name,
 						orig->active_slave.index);
 
-	for (i = 0; i < orig->slaves.count; ++i) {
-		const ni_bonding_slave_t *o = orig->slaves.data[i];
-		ni_bonding_slave_t *s = ni_bonding_slave_new();
-		ni_netdev_ref_set(&s->device, o->device.name, o->device.index);
-		s->info = ni_bonding_slave_info_ref(o->info);
-		ni_bonding_slave_array_append(&bond->slaves, s);
-	}
 #undef C
 
 	return bond;
@@ -571,140 +571,6 @@ ni_bonding_is_valid_arp_ip_target(const char *target)
 	return TRUE;
 }
 
-/*
- * Copy the slave names into the name array
- */
-void
-ni_bonding_get_slave_names(const ni_bonding_t *bonding, ni_string_array_t *array)
-{
-	unsigned int i;
-
-	if (!bonding || !array)
-		return;
-
-	ni_string_array_destroy(array);
-	for (i = 0; i < bonding->slaves.count; ++i) {
-		ni_bonding_slave_t *slave = bonding->slaves.data[i];
-
-		if (!slave || ni_string_empty(slave->device.name))
-			continue;
-
-		ni_string_array_append(array, slave->device.name);
-	}
-}
-
-/*
- * Report if the bond contains a slave device
- */
-ni_bool_t
-ni_bonding_has_slave(ni_bonding_t *bonding, const char *ifname)
-{
-	if (!bonding || ni_string_empty(ifname))
-		return FALSE;
-
-	return ni_bonding_slave_array_index_by_ifname(&bonding->slaves, ifname) != -1U;
-}
-
-/*
- * Add a slave device to the bond
- */
-ni_bonding_slave_t *
-ni_bonding_add_slave(ni_bonding_t *bonding, const char *ifname)
-{
-	ni_bonding_slave_t *slave;
-
-	if (!bonding || ni_string_empty(ifname))
-		return NULL;
-
-	if ((slave = ni_bonding_slave_new())) {
-
-		ni_netdev_ref_set_ifname(&slave->device, ifname);
-		if (ni_bonding_slave_array_append(&bonding->slaves, slave))
-			return slave;
-
-		ni_bonding_slave_free(slave);
-	}
-	return NULL;
-}
-
-ni_bonding_slave_t *
-ni_bonding_bind_slave(ni_bonding_t *bonding, const ni_netdev_ref_t *ref, const char *ifname)
-{
-	ni_bonding_slave_t *slave;
-
-	if (!bonding || !ref || !ref->index || ni_string_empty(ref->name)) {
-		ni_debug_verbose(NI_LOG_DEBUG, NI_TRACE_EVENTS,
-				"%s: bind of bonding slave %s[%u] skipped -- invalid args",
-				ifname, ref ? ref->name : NULL, ref ? ref->index : 0);
-		return NULL;
-	}
-
-	slave = ni_bonding_slave_array_get_by_ifindex(&bonding->slaves, ref->index);
-	if (slave) {
-		if (ni_string_eq(slave->device.name, ref->name)) {
-			ni_debug_verbose(NI_LOG_DEBUG2, NI_TRACE_EVENTS,
-					"%s: bonding slave %s[%u] is up to date",
-					ifname, slave->device.name, slave->device.index);
-		} else {
-			ni_debug_verbose(NI_LOG_DEBUG2, NI_TRACE_EVENTS,
-					"%s: rebind of bonding slave %s[%u] ifname to %s",
-					ifname, slave->device.name, slave->device.index, ref->name);
-
-			ni_netdev_ref_set_ifname(&slave->device, ref->name);
-		}
-		return slave;
-	}
-
-	slave = ni_bonding_slave_new();
-	if (slave) {
-		ni_netdev_ref_set(&slave->device, ref->name, ref->index);
-		if (ni_bonding_slave_array_append(&bonding->slaves, slave)) {
-			ni_debug_verbose(NI_LOG_DEBUG2, NI_TRACE_EVENTS,
-					"%s: bound new bonding slave %s[%u]",
-					ifname, slave->device.name, slave->device.index);
-			return slave;
-		}
-
-		ni_bonding_slave_free(slave);
-	}
-
-	ni_error("%s: unable to bind new slave %s[%u]", ifname, ref->name, ref->index);
-	return NULL;
-}
-
-ni_bool_t
-ni_bonding_unbind_slave(ni_bonding_t *bonding, const ni_netdev_ref_t *ref, const char *ifname)
-{
-	const ni_bonding_slave_t *slave;
-	unsigned int pos;
-
-	if (!bonding || !ref || !ref->index) {
-		ni_debug_verbose(NI_LOG_DEBUG, NI_TRACE_EVENTS,
-				"%s: unbind of bonding slave %s[%u] skipped -- invalid args",
-				ifname, ref ? ref->name : NULL, ref ? ref->index : 0);
-		return FALSE;
-	}
-
-	pos = ni_bonding_slave_array_index_by_ifindex(&bonding->slaves, ref->index);
-	if (pos != -1U) {
-		slave = ni_bonding_slave_array_get(&bonding->slaves, pos);
-
-		if (slave)
-			ref = &slave->device;
-
-		ni_debug_verbose(NI_LOG_DEBUG2, NI_TRACE_EVENTS,
-				"%s: unbind of bonding slave %s[%u] by ifindex",
-				ifname, ref->name, ref->index);
-
-		return ni_bonding_slave_array_delete(&bonding->slaves, pos);
-	}
-
-	ni_debug_verbose(NI_LOG_DEBUG, NI_TRACE_EVENTS,
-			"%s: unbind of bonding slave %s[%u] skipped -- slave not found",
-			ifname, ref->name, ref->index);
-	return FALSE;
-}
-
 /*
  * Set the bonding mode, using the strings supported by the
  * module options
@@ -951,15 +817,15 @@ ni_bonding_arp_validate_targets_to_type(const char *name)
 }
 
 const char *
-ni_bonding_slave_state_name(unsigned int mode)
+ni_bonding_port_state_name(unsigned int mode)
 {
-	return ni_format_uint_mapped(mode, ni_bonding_slave_state_map);
+	return ni_format_uint_mapped(mode, ni_bonding_port_state_map);
 }
 
 const char *
-ni_bonding_slave_mii_status_name(unsigned int mode)
+ni_bonding_port_mii_status_name(unsigned int mode)
 {
-	return ni_format_uint_mapped(mode, ni_bonding_slave_mii_status_map);
+	return ni_format_uint_mapped(mode, ni_bonding_port_mii_status_map);
 }
 
 /*
@@ -1193,16 +1059,10 @@ ni_bonding_parse_sysfs_attrs(const char *ifname, ni_bonding_t *bonding)
 		{ "lp_interval",	TRUE  },
 		{ NULL,			FALSE },
 	};
-	ni_string_array_t slave_names = NI_STRING_ARRAY_INIT;
 	char *attrval = NULL;
 	unsigned int i;
 
 	__ni_bonding_clear(bonding);
-	ni_sysfs_bonding_get_slaves(ifname, &slave_names);
-	for (i = 0; i < slave_names.count; ++i)
-		ni_bonding_add_slave(bonding, slave_names.data[i]);
-	ni_string_array_destroy(&slave_names);
-
 	for (i = 0; attrs[i].name; ++i) {
 		const char *attrname = attrs[i].name;
 		int rv;
@@ -1282,7 +1142,8 @@ ni_bonding_write_one_sysfs_attr(const char *ifname, const ni_bonding_t *bonding,
  * as well as in dependency of the bonding up/down state and slave count.
  */
 int
-ni_bonding_write_sysfs_attrs(const char *ifname, const ni_bonding_t *bonding, ni_bonding_t *current, ni_bool_t is_up, ni_bool_t has_slaves)
+ni_bonding_write_sysfs_attrs(const char *ifname, const ni_bonding_t *bonding,
+	ni_bonding_t *current, ni_bool_t is_up, ni_bool_t has_ports)
 {
 	/*
 	 * option		up/down	slaves		modes
@@ -1352,9 +1213,9 @@ ni_bonding_write_sysfs_attrs(const char *ifname, const ni_bonding_t *bonding, ni
 			continue;
 		if (attrs[i].bstate == 2 && !is_up)
 			continue;
-		if (attrs[i].slaves == 1 && has_slaves)
+		if (attrs[i].slaves == 1 && has_ports)
 			continue;
-		if (attrs[i].slaves == 2 && !has_slaves)
+		if (attrs[i].slaves == 2 && !has_ports)
 			continue;
 
 		if (attrs[i].islist) {
@@ -1627,221 +1488,51 @@ ni_bonding_set_option(ni_bonding_t *bond, const char *option, const char *value)
 	return FALSE;
 }
 
-void
-ni_bonding_slave_info_reset(ni_bonding_slave_info_t *info)
-{
-	info->state = -1U;
-	info->mii_status = -1U;
-	info->queue_id = -1U;
-	info->ad_aggregator_id = -1U;
-	ni_link_address_init(&info->perm_hwaddr);
-}
-
-ni_bonding_slave_info_t *
-ni_bonding_slave_info_new(void)
-{
-	ni_bonding_slave_info_t *info;
-
-	info = xcalloc(1, sizeof(*info));
-	info->refcount = 1;
-	ni_bonding_slave_info_reset(info);
-	return info;
-}
-
-ni_bonding_slave_info_t *
-ni_bonding_slave_info_ref(ni_bonding_slave_info_t *info)
-{
-	if (info) {
-		ni_assert(info->refcount);
-		info->refcount++;
-	}
-	return info;
-}
-
-void
-ni_bonding_slave_info_free(ni_bonding_slave_info_t *info)
-{
-	if (info) {
-		ni_assert(info->refcount);
-		info->refcount--;
-
-		if (info->refcount == 0)
-			free(info);
-	}
-}
-
-ni_bonding_slave_t *
-ni_bonding_slave_new(void)
+/*
+ * Bonding port (link-request) configuration
+ */
+ni_bonding_port_config_t *
+ni_bonding_port_config_new(void)
 {
-	ni_bonding_slave_t *slave;
+	ni_bonding_port_config_t *conf;
 
-	slave = xcalloc(1, sizeof(*slave));
-	return slave;
+	if ((conf = malloc(sizeof(*conf))))
+		conf->queue_id = -1U;
+	return conf;
 }
 
 void
-ni_bonding_slave_free(ni_bonding_slave_t *slave)
+ni_bonding_port_config_free(ni_bonding_port_config_t *conf)
 {
-	if (slave) {
-		ni_netdev_ref_destroy(&slave->device);
-		ni_bonding_slave_info_free(slave->info);
-		free(slave);
-	}
-}
-
-ni_bonding_slave_info_t *
-ni_bonding_slave_get_info(ni_bonding_slave_t *slave)
-{
-	if (slave) {
-		if (!slave->info)
-			slave->info = ni_bonding_slave_info_new();
-		return slave->info;
-	}
-	return NULL;
+	free(conf);
 }
 
+/*
+ * Bonding port interface info properties
+ */
 void
-ni_bonding_slave_set_info(ni_bonding_slave_t *slave, ni_bonding_slave_info_t *info)
-{
-	if (slave) {
-		ni_bonding_slave_info_t *temp;
-
-		temp = ni_bonding_slave_info_ref(info);
-		ni_bonding_slave_info_free(slave->info);
-		slave->info = temp;
-	}
-}
-
-static inline void
-ni_bonding_slave_array_init(ni_bonding_slave_array_t *array)
-{
-	memset(array, 0, sizeof(*array));
-}
-
-static void
-ni_bonding_slave_array_realloc(ni_bonding_slave_array_t *array, unsigned int newsize)
-{
-	ni_bonding_slave_t **newdata;
-	unsigned int i;
-
-	newsize += NI_BONDING_SLAVE_ARRAY_CHUNK;
-	newdata = xrealloc(array->data, newsize * sizeof(ni_bonding_slave_t *));
-	array->data = newdata;
-	for (i = array->count; i < newsize; ++i)
-		array->data[i] = NULL;
-}
-
-ni_bool_t
-ni_bonding_slave_array_append(ni_bonding_slave_array_t *array, ni_bonding_slave_t *slave)
+ni_bonding_port_info_reset(ni_bonding_port_info_t *info)
 {
-	if (!array || !slave)
-		return FALSE;
-
-	if ((array->count % NI_BONDING_SLAVE_ARRAY_CHUNK) == 0)
-		ni_bonding_slave_array_realloc(array, array->count);
-
-	array->data[array->count++] = slave;
-	return TRUE;
-}
-
-ni_bonding_slave_t *
-ni_bonding_slave_array_remove(ni_bonding_slave_array_t *array, unsigned int index)
-{
-	ni_bonding_slave_t *slave;
-
-	if (!array || index >= array->count)
-		return NULL;
-
-	slave = array->data[index];
-	array->count--;
-	if (index < array->count) {
-		memmove(&array->data[index], &array->data[index + 1],
-			(array->count - index) * sizeof(slave));
-	}
-	array->data[array->count] = NULL;
-	return slave;
+	info->state = -1U;
+	info->mii_status = -1U;
+	info->queue_id = -1U;
+	info->ad_aggregator_id = -1U;
+	ni_link_address_init(&info->perm_hwaddr);
 }
 
-ni_bool_t
-ni_bonding_slave_array_delete(ni_bonding_slave_array_t *array, unsigned int index)
+ni_bonding_port_info_t *
+ni_bonding_port_info_new(void)
 {
-	ni_bonding_slave_t *slave;
+	ni_bonding_port_info_t *info;
 
-	if (!(slave = ni_bonding_slave_array_remove(array, index)))
-		return FALSE;
-
-	ni_bonding_slave_free(slave);
-	return TRUE;
+	if ((info = malloc(sizeof(*info))))
+		ni_bonding_port_info_reset(info);
+	return info;
 }
 
 void
-ni_bonding_slave_array_destroy(ni_bonding_slave_array_t *array)
-{
-	if (array) {
-		while (array->count > 0)
-			ni_bonding_slave_free(array->data[--array->count]);
-		free(array->data);
-
-		ni_bonding_slave_array_init(array);
-	}
-}
-
-unsigned int
-ni_bonding_slave_array_index_by_ifname(ni_bonding_slave_array_t *array, const char *ifname)
+ni_bonding_port_info_free(ni_bonding_port_info_t *info)
 {
-	unsigned int i;
-
-	if (!array || !ifname)
-		return -1U;
-
-	for (i = 0; i < array->count; ++i) {
-		ni_bonding_slave_t *slave = array->data[i];
-
-		if (slave && ni_string_eq(ifname, slave->device.name))
-			return i;
-	}
-	return -1U;
-}
-
-unsigned int
-ni_bonding_slave_array_index_by_ifindex(ni_bonding_slave_array_t *array, unsigned int ifindex)
-{
-	unsigned int i;
-
-	if (!array || !ifindex)
-		return -1U;
-
-	for (i = 0; i < array->count; ++i) {
-		ni_bonding_slave_t *slave = array->data[i];
-
-		if (slave && ifindex == slave->device.index)
-			return i;
-	}
-	return -1U;
-}
-
-ni_bonding_slave_t *
-ni_bonding_slave_array_get(ni_bonding_slave_array_t *array, unsigned int index)
-{
-	if (!array || index >= array->count)
-		return NULL;
-
-	return array->data[index];
-}
-
-ni_bonding_slave_t *
-ni_bonding_slave_array_get_by_ifname(ni_bonding_slave_array_t *array, const char *ifname)
-{
-	unsigned int index = ni_bonding_slave_array_index_by_ifname(array, ifname);
-
-	return ni_bonding_slave_array_get(array, index);
-}
-
-ni_bonding_slave_t *
-ni_bonding_slave_array_get_by_ifindex(ni_bonding_slave_array_t *array, unsigned int ifindex)
-{
-	unsigned int index = ni_bonding_slave_array_index_by_ifindex(array, ifindex);
-
-	return ni_bonding_slave_array_get(array, index);
+	free(info);
 }
 
